<?php

namespace App\Filament\Exports;

use App\Models\ProductionLineStop;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class ProductionLineStopExporter extends Exporter
{
    protected static ?string $model = ProductionLineStop::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;

        return [
            // ExportColumn::make('id')
            //     ->label('ID'),
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('linestop.code')
                ->label('CODE'),
            ExportColumn::make('linestop.reason')
                ->label('REASON'),
            ExportColumn::make('from_datetime')
                ->label('FROM DATETIME'),
            ExportColumn::make('to_datetime')
                ->label('TO DATETIME'),
            ExportColumn::make('stop_hour')
                ->label('STOP HOUR'),
            ExportColumn::make('stop_min')
                ->label('STOP MINUTE'),
            ExportColumn::make('line.name')
                ->label('LINE NAME'),
            ExportColumn::make('shift.block.name')
                ->label('BLOCK NAME'),
            ExportColumn::make('shift.name')
                ->label('SHIFT NAME'),
            ExportColumn::make('plant.code')
                ->label('PLANT CODE'),
            ExportColumn::make('operator_id')
                ->label('OPERATOR ID'),
            ExportColumn::make('created_at')
                ->label('CREATED AT'),
            ExportColumn::make('updated_at')
                ->label('UPDATED AT'),
            ExportColumn::make('deleted_at')
                ->enabledByDefault(false)
                ->label('DELETED AT'),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your production line stop export has completed and '.number_format($export->successful_rows).' '.str('row')->plural($export->successful_rows).' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' '.number_format($failedRowsCount).' '.str('row')->plural($failedRowsCount).' failed to export.';
        }

        return $body;
    }
}
